/*
	Written by krax, 2010
	tripCrack.c, this file is hereby released to the public domain.

*/

#include <stdio.h>
#include <string.h>
#include <locale.h>

#define C_COMMON	1
#define C_ALL		2
#define C_LETTERS	3
#define C_NUMERIC 	4

#define max_len 9
char *crypt(char* key, char* salt);

int cr0[max_len+1];
char cr1[max_len+1];
char bufx[11];
char slt[3]={0,0,0};
char slup[256]={'.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','/','0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F','G','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','a','b','c','d','e','f','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.','.'};
static char * charset_all = "\0!\"$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~";
static char * charset_common = "\0+-./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
static char * charset_numeric = "\0+-.0123456789";
static char * charset_letters = "\0ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";

static char * crypt_charset = "./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";

char * charset;
int chlen;
char * match;
int mlen;

void pchars(char* s)
{
	printf("Using Charset: %s\n",s);
}

char * basex(char*loc)
{
	int i=0;
	char * ret = loc;
	while(loc[i++] != 0)
	{
		if(loc[i]=='\\')
		{
			ret=&loc[i+1];
		}
		if(loc[i+1]=='/')
		{
			ret=&loc[i];
		}
	}
	return ret;
}

void print_usage(char*loc)
{
	printf("\nUsage: %s [options] [hash or part of hash]\n",basex(loc));
	printf("Options:\n");
	printf("  -c\tCharset (common,all,letters,numeric) common is default\n");
	printf("  -h\tHelp (Display this)\n");
	printf("Note: The \"all\" charset is somewhat unreliable\n");
	printf("\n");
	exit(0);
}


int main(int argc, char* argv[])
{
	setlocale(LC_ALL, "");
	
	int charset_t=C_COMMON;
	
	if(argc<2){print_usage(argv[0]);}
	if(strcmp("-h",argv[1])==0){print_usage(argv[0]);}
	
	if(strcmp("-c",argv[1])==0)
	{
		if(argc>3)
		{
			charset_t=0;
			if(strcmp("common",argv[2])==0){charset_t=C_COMMON;}
			if(strcmp("all",argv[2])==0){charset_t=C_ALL;}
			if(strcmp("letters",argv[2])==0){charset_t=C_LETTERS;}
			if(strcmp("numeric",argv[2])==0){charset_t=C_NUMERIC;}
		}
		else
		{
			printf("Error: Bad arguments\n");return -2;
		}
	}
	
	switch(charset_t)
	{
		case C_COMMON: pchars("common");charset=charset_common;break;
		case C_ALL: pchars("all");charset=charset_all;break;
		case C_LETTERS: pchars("letters");charset=charset_letters;break;
		case C_NUMERIC: pchars("numeric");charset=charset_numeric;break;
		default: printf("Error: Unknown charset.\n");return -1;
	}
	chlen=strlen(&charset[1]);
	printf("Charset size: %i\n",chlen);
	
	char * mx = argv[argc-1];
	int i,j;
	mlen=strlen(mx);
	if(mlen > 10)
	{
		printf("Error: hash to large\n");return -3;
	}
	for(i=0;i<mlen;++i)
	{
		if(!strchr(crypt_charset,mx[i]))
		{
			printf("Error: uncrackable hash\n");return -4;
		}
	}
	
	printf("Checking for matches against: %s\n",mx);
	match=malloc(mlen);
	strcpy(match,mx);
	
	for(i=0;i<mlen;++i)
	{
		match[i]=tolower(match[i]);
	}
	char d=0;
	for(;;)
	{
		for(i=0;i<max_len;++i)
		{
			++cr0[i];
			if(cr0[i]<=chlen){break;}
			cr0[i]=1;
			if(i+1==max_len)
			{
				d=1;
			}
		}
		if(d){break;}
		
		cr1[0]=charset[cr0[0]];
		cr1[1]=charset[cr0[1]];
		cr1[2]=charset[cr0[2]];
		cr1[3]=charset[cr0[3]];
		cr1[4]=charset[cr0[4]];
		cr1[5]=charset[cr0[5]];
		cr1[6]=charset[cr0[6]];
		cr1[7]=charset[cr0[7]];
		cr1[8]=charset[cr0[8]];
		
		if(cr1[1]==0)
		{
			slt[0]='H';
			slt[1]='.';
		}
		else
		{
			if(cr1[2]==0)
			{
				slt[0]=slup[cr1[1]];
				slt[1]='H';
			}
			else
			{
				slt[0]=slup[cr1[1]];
				slt[1]=slup[cr1[2]];
			}
		}
		
		char * bf = &(crypt(cr1,slt))[3];
		for(j=0;j<10;++j)
		{
			bufx[j]=tolower(bf[j]);
		}
		
		if(0 != strstr(bufx,match))
		{
			printf("%s - %s\n",cr1,bf);
		}
	}
}

